//This is a sample C++ program for Borland C++ (Version 5.0 and later),
//which is to be linked to PSIM via DLL.

//To compile it into DLL:

//   From Borland C++ environment:
//      - From the "File" menu, choose "New"/"Project". Set the project
//        name as "bc_user0.ide", the Target Type as "Dynamic Library [.dll]",
//        the Platform as "Win32", and select "Static" link.
//      - Copy this sample file into the directory where the project resides.
//      - From the "Project" window, delete the files "bc_user0.def" and
//        "bc_user0.rc".
//      - Make sure that, in the "Option" menu, under "Project"/"32-bit Compilers"/
//        "Calling Convention", calling convention "C" is selected.
//      - From the "Build" menu, choose "Build All".

//After the DLL file "bc_user0.dll" is generated, backup the default DLL file
//into another file or directory, and copy your DLL file into the PSIM
//directory (and overwriting the existing file). You are then ready to run
//PSIM with your DLL.


//This sample program calculates the rms value of a 60-Hz input in[0],
//and stores the result in out[0].

//Do not change the following line.
extern "C"
{

//You may change the variable names (say from "t" to "Time").
//But DO NOT change the function name, number of variables,
//variable type, and sequence.

// Variables:
//      t: Time, passed from PSIM by value
//   delt: Time step, passed from PSIM by value
//     in: input array, passed from PSIM by reference
//    out: output array, sent back to PSIM (Note: the values of out[*] can
//         be modified in PSIM)

// The maximum length of the input and output array "in" and "out" is 20.

#include <math.h>
void __declspec(dllexport) bc_user0 (double t, double delt, double *in, double *out)

{
//Place your code here............begin

//  Define "sum" as "static" in order to retain its value.
	static double nsum=0., sum=0., rms;
	double Tperiod;

	Tperiod=1./60.;

	if (t >= nsum*Tperiod)
	{
		nsum=nsum+1.;
		rms = sqrt(sum*delt/Tperiod);
      sum=0.;
	}

   out[0] = rms;
	sum=sum+in[0]*in[0];

//Place your code here............end
}

}
