//This is a sample C++ program for Borland C++ (Version 5.0 and later),
//which is to be linked to PSIM via DLL.

//To compile it into DLL:

//   From Borland C++ environment:
//      - From the "File" menu, choose "New"/"Project". Set the project
//        name as "bc_user3.ide", the Target Type as "Dynamic Library [.dll]",
//        the Platform as "Win32", and select "Static" link.
//      - Copy this sample file into the directory where the project resides.
//      - From the "Project" window, delete the files "bc_user3.def" and
//        "bc_user3.rc".
//      - Make sure that, in the "Option" menu, under "Project"/"32-bit Compilers"/
//        "Calling Convention", calling convention "C" is selected.
//      - From the "Build" menu, choose "Build All".

//After the DLL file "bc_user3.dll" is generated, backup the default DLL file
//into another file or directory, and copy your DLL file into the PSIM
//directory (and overwriting the existing file). You are then ready to run
//PSIM with your DLL.

//This sample program calculates the rms value of a 60-Hz input in[0],
//which is sampled at a sampling rate of 2400 Hz. The rms output is
//stored in out[0], and the intermediate variable sum is stored in out[1].

//Do not change the following line.
extern "C"
{

//You may change the variable names (say from "t" to "Time").
//But DO NOT change the function name, number of variables,
//variable type, and sequence.

// Variables:
//      t: Time, passed from PSIM by value
//   delt: Time step, passed from PSIM by value
//     in: input array, passed from PSIM by reference
//    out: output array, sent back to PSIM (Note: the values of out[*] can
//         be modified in PSIM)

// The maximum length of the input and output array "in" and "out" is 20.

#include <math.h>
void __declspec(dllexport) bc_user3 (double t, double delt, double *in, double *out)

{
//Place your code here............begin

	int i;
	static double nsum=0, sum=0, avg;
	double Ts, Tperiod;

// Fundamental frequency 60 Hz; sampling frequency 2400 Hz.
	Ts=1./2400.;
	Tperiod=1./60.;

	if (t >= nsum*Tperiod)
	{
		nsum=nsum+1;
		avg = sqrt(sum*Ts/Tperiod);
		sum=0.;
	}

   out[0] = avg;
	sum=sum+in[0]*in[0];
	out[1]=sum;

//Place your code here............end
}

}
